/**
 * $Id$
 *
 * Copyright (C) shinichiro.h <hamaji@nii.ac.jp>
 *  http://shinh.skr.jp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef omf_h_
#define omf_h_

typedef struct {
    int type;
    int size;
    int off;
    char* cont;
    int sum;
} OMF_Record;

typedef struct {
    int record_size;
    OMF_Record* records;
    int dict_off, dict_size;
    char* dictionary;
} OMF;

OMF* OMF_load(const char* filename);
void OMF_save(OMF* omf, const char* filename);
void OMF_free(OMF* omf);

extern char* OMF_record_type_name[];

#endif // ! omf_h_

