#include "omf.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static void arx(OMF* omf) {
    OMF_Record* r = omf->records;

    if (r->type != 0xf0) {
        printf("this is not .lib file\n");
        return;
    }
    r++;

    while (r->type == 0x80) {
        OMF omf;
        char buf[256];
        char* srcname;
        char* p;

        strcpy(buf, r->cont+1);
        srcname = buf;

        while ((p = strchr(srcname, '\\'))) *p = '_';
        while ((p = strchr(srcname, '/'))) *p = '_';

        strcat(srcname, ".obj");

        memset(&omf, 0, sizeof(OMF));

        while (1) {
            omf.record_size++;
            omf.records = (OMF_Record*)realloc(
                omf.records, sizeof(OMF_Record)*omf.record_size);
            omf.records[omf.record_size-1] = *r;
            omf.records[omf.record_size-1].off = 0;
            if (r->type == 0x8a || r->type == 0x8b) break;
            r++;
        }
        r++;

        OMF_save(&omf, srcname);
        free(omf.records);
    }
}

int main(int argc, char* argv[]) {
    const char* filename;
    OMF* omf;

    if (argc == 1) {
        printf("usage: %s file\n", argv[0]);
        exit(1);
    }
    filename = argv[1];

    omf = OMF_load(filename);
    if (!omf) return 1;
    arx(omf);
    OMF_free(omf);

    return 0;
}

