#include "omf.h"

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

static void dump_record(OMF_Record r) {
    int i, l = 60;

    printf("%7s", OMF_record_type_name[r.type]);
//    printf("/%02x %06x+%04x ", r.type, r.off, r.size);
    printf(" %06x+%03x ", r.off, r.size);
    if (r.size < l) l = r.size;
    for (i = 0; i < l; i++) {
        char c = r.cont[i];
        if (isprint(c)) printf("%c", c);
        else printf(".");
    }
    if (l <= 10) {
        printf(" ");
        for (i = 0; i < l; i++) {
            char c = r.cont[i];
            printf("%02x ", (unsigned char)c);
        }
    }
    printf("\n");
}

static void dump(OMF* omf) {
    int i;
    for (i = 0; i < omf->record_size; i++) {
        dump_record(omf->records[i]);
    }
}

int main(int argc, char* argv[]) {
    const char* filename;
    OMF* omf;

    if (argc == 1) {
        printf("usage: %s file\n", argv[0]);
        exit(1);
    }
    filename = argv[1];

    omf = OMF_load(filename);
    if (!omf) return 1;
    dump(omf);
    OMF_free(omf);

    return 0;
}

