#include "omf.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

static void nm_record(OMF_Record r) {
    char* p;
    char type = '\0';

    /* PUBDEF */
    if (r.type == 0x90 || r.type == 0x91) {
        p = r.cont;
        int bgi = (unsigned char)*p++;
        int bsi = (unsigned char)*p++;
        if (bsi == 0) {
/*            int bf = *(short*)p; */
            p += 2;
        }

        while (p < r.cont+r.size && *p) {
            int size;
            int po, ti;
            char buf[512];
            size = *p++;

            memcpy(buf, p, size);
            buf[size] = '\0';

            p += size;
            po = *(int*)p;
            p += 4;
            ti = *p++;

            printf("%02x %02x ", bgi, bsi);
            printf("%08x T %s\n", po, buf);
/*            printf("%08x %02x T %s\n", po, ti, buf); */
        }
    }

    /* EXTDEF */
    if (r.type == 0x8c) type = 'U';
    /* THEADR */
    else if (r.type == 0x80) type = 'O';
#if 1
    /* LNAMES */
    else if (r.type == 0x96) type = 'T';
#endif

    if (!type) return;

    for (p = r.cont; p < r.cont+r.size && *p; ) {
        int size = *p;
        p++;
        p[size] = '\0';
        printf("               %c %s\n", type, p);
        p += size;
    }
}

static void nm(OMF* omf) {
    int i;
    for (i = 0; i < omf->record_size; i++) {
        nm_record(omf->records[i]);
    }
}

int main(int argc, char* argv[]) {
    const char* filename;
    OMF* omf;

    if (argc == 1) {
        printf("usage: %s file\n", argv[0]);
        exit(1);
    }
    filename = argv[1];

    omf = OMF_load(filename);
    if (!omf) return 1;
    nm(omf);
    OMF_free(omf);

    return 0;
}

